unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  DAO_TLB, StdCtrls, ComCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    TreeView1: TTreeView;
    ImageList1: TImageList;
    PageControl1: TPageControl;
    shEmpty: TTabSheet;
    shProperties: TTabSheet;
    ScrollBox1: TScrollBox;
    Label1: TLabel;
    OpenDialog1: TOpenDialog;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure TreeView1Change(Sender: TObject; Node: TTreeNode);
  private
    { Private declarations }
    Engine : DBEngine;
    DB     : Database;
    Procedure ReadDatabase;
  public
    { Public declarations }
  end;


Const
  siNone       = 01;
  siProperties = 02;

  imgFolder     = 00;
  imgEngine     = 01;
  imgTable      = 02;
  imgQuery      = 03;
  imgField      = 04;
  imgIndex      = 05;
  imgDocuments  = 06;
  imgDocument   = 07;
  imgOther      = 08;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.ReadDatabase;
Var TN_Engine,
    TN_WorkSpaces,
    TN_MyDatabase,
    Sibl1,
    Sibl2,
    Node  : TtreeNode;
    I,J,K : Integer;
Begin
  TreeView1.Items.BeginUpdate;
  TreeView1.Items.Clear;

  TN_Engine := TreeView1.Items.AddObject (nil, 'DB Engine', Pointer (Engine.Properties));
  TN_Engine.StateIndex := siProperties;
  TN_Engine.ImageIndex := imgEngine;
  TN_Engine.SelectedIndex := imgEngine;
  TN_Engine.Expanded := True;

  TN_Workspaces := TreeView1.Items.AddChild (TN_Engine, 'Workspaces');
  TN_Workspaces.StateIndex := siNone;
  TN_Workspaces.ImageIndex := imgOther;
  TN_Workspaces.SelectedIndex := imgOther;

  For I := 0 to Engine.Workspaces.Count-1 Do Begin
    Node := TreeView1.Items.AddChildObject (TN_Workspaces, Engine.Workspaces.Item[I].Name, Pointer (Engine.Workspaces.Item[I].Properties));
    Node.StateIndex := siProperties;
    Node.ImageIndex := imgOther;
    Node.SelectedIndex := imgOther;

    Sibl1 := TreeView1.Items.AddChild (Node, 'Databases');
    Sibl1.StateIndex := siNone;
    Sibl1.ImageIndex := imgOther;
    Sibl1.SelectedIndex := imgOther;
    {This is how it should be, but this way I'm unable to retrieve wich node has my database...}
    {
    For J := 0 to Engine.Workspaces.Item[I].DataBases.Count-1 Do
      With TreeView1.Items.AddChildObject (Sibl1, Engine.Workspaces.Item[I].DataBases.Item[J].Name, Pointer (Engine.Workspaces.Item[I].DataBases.Item[J].Properties)) Do Begin
        StateIndex := siProperties;
        ImageIndex := imgOther;
        SelectedImage := imgOther;
      End;
    }
    {So we show only 1 database...}
    If I = 0 Then Begin
      TN_MyDatabase := TreeView1.Items.AddChildObject (Sibl1, Engine.Workspaces.Item[0].DataBases.Item[0].Name, Pointer (Engine.Workspaces.Item[0].DataBases.Item[0].Properties));
      With TN_MyDatabase Do Begin
        StateIndex := siProperties;
        ImageIndex := imgOther;
        SelectedIndex := imgOther;
      End;
    End;

    Sibl1 := TreeView1.Items.AddChild (Node, 'Users');
    Sibl1.StateIndex := siNone;
    Sibl1.ImageIndex := imgOther;
    Sibl1.SelectedIndex := imgOther;
    For J := 0 to Engine.Workspaces.Item[I].Users.Count-1 Do
      With TreeView1.Items.AddChildObject (Sibl1, Engine.Workspaces.Item[I].Users.Item[J].Name, Pointer (Engine.Workspaces.Item[I].Users.Item[J].Properties)) Do Begin
        StateIndex := siProperties;
        ImageIndex := imgOther;
        SelectedIndex := imgOther;
        {User->Group->User->Group->User, etc, etc, etc...}
      End;

    Sibl1 := TreeView1.Items.AddChild (Node, 'Groups');
    Sibl1.StateIndex := siNone;
    Sibl1.ImageIndex := imgOther;
    Sibl1.SelectedIndex := imgOther;
    For J := 0 to Engine.Workspaces.Item[I].Groups.Count-1 Do Begin
      Sibl2 := TreeView1.Items.AddChildObject (Sibl1, Engine.Workspaces.Item[I].Groups.Item[J].Name, Pointer (Engine.Workspaces.Item[I].Groups.Item[J].Properties));
      With Sibl2 Do Begin
        StateIndex := siProperties;
        ImageIndex := imgOther;
        SelectedIndex := imgOther;
        For K := 0 to Engine.Workspaces.Item[I].Groups.Item[J].Users.Count-1 Do
          With TreeView1.Items.AddChildObject (Sibl2, Engine.Workspaces.Item[I].Groups.Item[J].Users.Item[K].Name, Pointer (Engine.Workspaces.Item[I].Groups.Item[J].Users.Item[K].Properties)) Do Begin
            StateIndex := siProperties;
            ImageIndex := imgOther;
            SelectedIndex := imgOther;
            {User->Group->User->Group->User, etc, etc, etc...}
          End;
      End;
    End;
      {Connections not accessable ?!?!}
  End;

  Sibl1 := TreeView1.Items.AddChild (TN_MyDatabase, 'Tables');
  Sibl1.StateIndex := siNone;
  Sibl1.ImageIndex := imgOther;
  Sibl1.SelectedIndex := imgOther;

  For I := 0 to DB.TableDefs.Count-1 Do Begin
    Node := TreeView1.Items.AddChildObject (Sibl1, DB.TableDefs.Item[I].Name, Pointer (DB.TableDefs.Item[I].Properties));
    Node.StateIndex := siProperties;
    Node.ImageIndex := imgTable;
    Node.SelectedIndex := imgTable;

    Sibl2 := TreeView1.Items.AddChild (Node, 'Fields');
    Sibl2.StateIndex := siNone;
    Sibl2.ImageIndex := imgOther;
    Sibl2.SelectedIndex := imgOther;

    For J := 0 To DB.TableDefs.Item[I].Fields.Count-1 Do
      With TreeView1.Items.AddChildObject (Sibl2, DB.TableDefs.Item[I].Fields[J].Name, Pointer (DB.TableDefs.Item[I].Fields[J].Properties)) Do Begin
        StateIndex := siProperties;
        ImageIndex := imgField;
        SelectedIndex := imgField;
      End;

    Sibl2 := TreeView1.Items.AddChild (Node, 'Indexes');
    Sibl2.StateIndex := siNone;
    Sibl2.ImageIndex := imgOther;
    Sibl2.SelectedIndex := imgOther;
    try
      For J := 0 To DB.TableDefs.Item[I].Indexes.Count-1 Do
        With TreeView1.Items.AddChildObject (Sibl2, DB.TableDefs.Item[I].Indexes[J].Name, Pointer (DB.TableDefs.Item[I].Indexes[J].Properties)) Do Begin
          StateIndex := siProperties;
          ImageIndex := imgIndex;
          SelectedIndex := imgIndex;
        End;
    except
    end
  End;

  Sibl1 := TreeView1.Items.AddChild (TN_MyDatabase, 'Queries');
  Sibl1.StateIndex := siNone;
  Sibl1.ImageIndex := imgOther;
  Sibl1.SelectedIndex := imgOther;

  For I := 0 to DB.QueryDefs.Count-1 Do Begin
    Node := TreeView1.Items.AddChildObject (Sibl1, DB.QueryDefs.Item[I].Name, Pointer (DB.QueryDefs.Item[I].Properties));
    Node.StateIndex := siProperties;
    Node.ImageIndex := imgQuery;
    Node.SelectedIndex := imgQuery;

    Sibl2 := TreeView1.Items.AddChild (Node, 'Fields');
    Sibl2.StateIndex := siNone;
    Sibl2.ImageIndex := imgOther;
    Sibl2.SelectedIndex := imgOther;
    For J := 0 To DB.QueryDefs.Item[I].Fields.Count-1 Do
      With TreeView1.Items.AddChildObject (Sibl2, DB.QueryDefs.Item[I].Fields[J].Name, Pointer (DB.QueryDefs.Item[I].Fields[J].Properties)) Do Begin
        StateIndex := siProperties;
        ImageIndex := imgField;
        SelectedIndex := imgField;
      End;

    Sibl2 := TreeView1.Items.AddChild (Node, 'Parameters');
    Sibl2.StateIndex := siNone;
    Sibl2.ImageIndex := imgOther;
    Sibl2.SelectedIndex := imgOther;
    For J := 0 To DB.QueryDefs.Item[I].Parameters.Count-1 Do
      With TreeView1.Items.AddChildObject (Sibl2, DB.QueryDefs.Item[I].Parameters[J].Name, Pointer (DB.QueryDefs.Item[I].Parameters[J].Properties)) Do Begin
        StateIndex := siProperties;
        ImageIndex := imgOther;
        SelectedIndex := imgOther;
      End;
  End;

  Sibl1 := TreeView1.Items.AddChild (TN_MyDatabase, 'Relations');
  Sibl1.StateIndex := siNone;
  Sibl1.ImageIndex := imgOther;
  Sibl1.SelectedIndex := imgOther;
  For I := 0 to DB.Relations.Count-1 Do Begin
    Node := TreeView1.Items.AddChildObject (Sibl1, DB.Relations.Item[I].Name, Pointer (DB.Relations.Item[I].Properties));
    Node.StateIndex := siProperties;
    Node.ImageIndex := imgOther;
    Node.SelectedIndex := imgOther;

    For J := 0 To DB.Relations.Item[I].Fields.Count-1 Do
      With TreeView1.Items.AddChildObject (Node, DB.Relations.Item[I].Fields[J].Name, Pointer (DB.Relations.Item[I].Fields[J].Properties)) Do Begin
        StateIndex := siProperties;
        ImageIndex := imgField;
        SelectedIndex := imgField;
      End;
  End;

  Sibl1 := TreeView1.Items.AddChild (TN_MyDatabase, 'Containers');
  Sibl1.StateIndex := siNone;
  Sibl1.ImageIndex := imgOther;
  Sibl1.SelectedIndex := imgOther;

  For I := 0 to DB.Containers.Count-1 Do Begin
    Node := TreeView1.Items.AddChildObject (Sibl1, DB.Containers.Item[I].Name, Pointer (DB.Containers.Item[I].Properties));
    Node.StateIndex := siProperties;
    Node.ImageIndex := imgOther;
    Node.SelectedIndex := imgOther;

    Sibl2 := TreeView1.Items.AddChild (Node, 'Documents');
    Sibl2.StateIndex := siNone;
    Sibl2.ImageIndex := imgDocuments;
    Sibl2.SelectedIndex := imgDocuments;

    For J := 0 To DB.Containers.Item[I].Documents.Count-1 Do
      With TreeView1.Items.AddChildObject (Sibl2, DB.Containers.Item[I].Documents[J].Name, Pointer (DB.Containers.Item[I].Documents[J].Properties)) Do Begin
        StateIndex := siProperties;
        ImageIndex := imgDocument;
        SelectedIndex := imgDocument;
      End;
  End;

  Sibl1 := TreeView1.Items.AddChild (TN_MyDatabase, 'Recordsets');
  Sibl1.StateIndex := siNone;
  Sibl1.ImageIndex := imgOther;
  Sibl1.SelectedIndex := imgOther;

  For I := 0 to DB.Recordsets.Count-1 Do
    With TreeView1.Items.AddChildObject (Sibl1, DB.Recordsets.Item[I].Name, Pointer (DB.Recordsets.Item[I].Properties)) Do Begin
      StateIndex := siProperties;
      ImageIndex := imgOther;
      SelectedIndex := imgOther;
    End;

  TreeView1.Items.EndUpdate;
End;

procedure TForm1.Button1Click(Sender: TObject);
begin
  If OpenDialog1.Execute Then Begin
    {Close existing database... not sure how to check it...}
    If DB<>nil Then DB.Close;

    DB := Engine.OpenDatabase(
      OpenDialog1.FileName,
      0,       {Options}
      True,   {ReadOnly}
      '');     {Connect}

    ReadDatabase;
  End;
end;

procedure TForm1.FormCreate(Sender: TObject);
const
  DAOLIC = 'mbmabptebkjcdlgtjmskjwtsdhjbmkmwtrak';
var
  pUnk: IUnknown;
  pClass2: IClassFactory2;
  licString2: Widestring;
begin
  pClass2 := nil;
  OleCheck (CoGetClassObject (CLASS_DBEngine,
    CLSCTX_INPROC_SERVER or CLSCTX_LOCAL_SERVER, nil, IClassFactory2,
    pClass2));
  if Assigned(pClass2) then begin
    Licstring2 := DAOLIC;
    OleCheck(pClass2.CreateInstanceLic (nil, nil, DBEngine, LicString2, Engine));
  end;
  //Engine := CoDBEngine.Create; <--- Existing call
end;

procedure TForm1.TreeView1Change(Sender: TObject; Node: TTreeNode);
Const FT : Array[Boolean] of String[5] = ('False', 'True');
Var I : Integer;
    Props : Properties;
    YPos  : Integer;
begin
  Case Node.StateIndex of
    siProperties : Begin
      {Show empty page, to prevent the ugly 'flashing'}
      PageControl1.ActivePage := shEmpty;

      {First remove all stuff from ScrollBox...}
      With ScrollBox1 Do
        While ControlCount > 0 Do Controls[0].Free;

      {Now, loop through all properties, and add those fields to the scrollbox}
      Props := Properties (Node.Data);
      YPos  := 8; {Pos of editbox, label starts at 12. Increment with 24 each line}

      For I := 0 To Props.Count-1 Do Begin
        {Create label (Property.Name), and add it to scrollbox}

        With TLabel.Create (ScrollBox1) Do Begin
          Parent := ScrollBox1;
          Alignment := taRightJustify;
          Caption := Props.Item[I].Name;
          Top := YPos+4;
          Left := 140 - Width;
        End;

        {Create editbox (Property.Value), and add it to scrollbox}
        With TEdit.Create (ScrollBox1) Do Begin
          Parent   := ScrollBox1;
          Width    := 305;
          Left     := 148;
          Top      := YPos;
          ReadOnly := True;
          try
            Text := Props.Item[I].Value;
          Except
            Text := '<Error>';
          End;
        End;

        Inc (YPos, 24);
      End;
      {tada...}
      PageControl1.ActivePage := shProperties;
    End;
    Else PageControl1.ActivePage := shEmpty;
  End;
end;

end.
